leetcode 529. Minesweeper

Let's play the minesweeper game (Wikipedia, online game)!

You are given a 2D char matrix representing the game board. 'M'represents an unrevealed mine, 'E' represents an unrevealed empty square, 'B' represents a revealed blank square that has no adjacent (above, below, left, right, and all 4 diagonals) mines, digit ('1' to '8') represents how many mines are adjacent to this revealed square, and finally 'X' represents a revealed mine.

Now given the next click position (row and column indices) among all the unrevealed squares ('M' or 'E'), return the board after revealing this position according to the following rules:

  1. If a mine ('M') is revealed, then the game is over - change it to 'X'.
  2. If an empty square ('E') with no adjacent mines is revealed, then change it to revealed blank ('B') and all of its adjacent unrevealedsquares should be revealed recursively.
  3. If an empty square ('E') with at least one adjacent mine is revealed, then change it to a digit ('1' to '8') representing the number of adjacent mines.
  4. Return the board when no more squares will be revealed.

Example 1:

Input:

[['E', 'E', 'E', 'E', 'E'],
['E', 'E', 'M', 'E', 'E'],
['E', 'E', 'E', 'E', 'E'],
['E', 'E', 'E', 'E', 'E']]

Click : [3,0]

Output:

[['B', '1', 'E', '1', 'B'],
['B', '1', 'M', '1', 'B'],
['B', '1', '1', '1', 'B'],
['B', 'B', 'B', 'B', 'B']]

Explanation:

image

Example 2:

Input:

[['B', '1', 'E', '1', 'B'],
['B', '1', 'M', '1', 'B'],
['B', '1', '1', '1', 'B'],
['B', 'B', 'B', 'B', 'B']]

Click : [1,2]

Output:

[['B', '1', 'E', '1', 'B'],
['B', '1', 'X', '1', 'B'],
['B', '1', '1', '1', 'B'],
['B', 'B', 'B', 'B', 'B']]

Explanation:

image

Note:

  1. The range of the input matrix's height and width is [1,50].
  2. The click position will only be an unrevealed square ('M' or 'E'), which also means the input board contains at least one clickable square.
  3. The input board won't be a stage when game is over (some mines have been revealed).
  4. For simplicity, not mentioned rules should be ignored in this problem. For example, you don't need to reveal all the unrevealed mines when the game is over, consider any cases that you will win the game or flag any squares.

这个是扫雷游戏,需要注意上面的四条规则,可以用DFS求解,在给定的位置上点击时,如果点到了地雷,那就改为‘X’,直接返回整个数组就行,如果没有点到地雷,根据上述的规则改相应的字母。还有,如果附近有地雷,那就根据周围地雷的数量,把自己的位置改为这个数字的str类型就行,并且在周围没有地雷的位置上继续递归,直到没有更多的点被揭露,返回整个方块。

注意:

  • 在Example 1中,在(0,3)位置上之所有没有揭露,那是因为它的线面有地雷,左右边是有'1',而且这个'1'所在的方块中,是不能继续递归下去的。所以最后(0,3)这个位置没有被揭露了。所以DFS就油然而生了。
  • 这个方向是有八个方向的。

python3代码:

class Solution:
    def updateBoard(self, board: List[List[str]], click: List[int]) -> List[List[str]]:
        lenr, lenc = len(board), len(board[0])
        if lenr == 0 or lenc == 0:
            return board
        
        sr, sc = click[0], click[1]
        if board[sr][sc] == 'M':
            board[sr][sc] = 'X'
            return board
        
        visited = [[0 for i in range(lenc + 1)] for j in range(lenr + 1)]
        dx = [1, 1, -1, -1, 0, 0, -1, 1]
        dy = [1, 0, -1, 0, 1, -1, 1, -1]
        
        def dfs(r, c):
            if board[r][c] == 'M' or visited[r][c] == 1:
                return
            visited[r][c] = 1
            num_mine = 0
            for i in range(8):
                x = r + dx[i]
                y = c + dy[i]
                if 0 <= x < lenr and 0 <= y < lenc and board[x][y] == 'M':
                    num_mine += 1
            if num_mine > 0:
                board[r][c] = str(num_mine)
            else:
                board[r][c] = 'B'
                
                for i in range(8):
                    x = r + dx[i]
                    y = c + dy[i]
                    
                    if 0 <= x < lenr and 0 <= y < lenc and visited[x][y] == 0:
                        dfs(x, y)
        dfs(sr, sc)
        return board

你可能感兴趣的:(leetcode 529. Minesweeper)